<template>
    <div class="h-100">
        <ObTable
            :columns="columns"
            :show-add-button="true"
            :items="formDataArray"
            :page-limit="1000"
            :data-grid-ref-name="'reasonsGrid'"
            :functional-panel="true"
            @add="addNewItem"
            @select="onSelection"
            :selected-row-keys-array="selectedRowKeys"
        >
            <div slot="footer">
                <span>Количество записей: {{formDataArray.length}}</span>
            </div>
        </ObTable>
        <ObModal
                ref="addModal"
                :title="newTitle"
                size="xl"
                :is-show-controls="false"
        >
            <add-popup @save="save" :field-list="formDataArray"/>
        </ObModal>
        <edit-popup ref="editModal" :data-source="formData"/>
    </div>
</template>

<script>
    import ObModal from "common-components/src/obComponents/obModal"
    import ObTable from "common-components/src/obComponents/obTable"
    import tableLayoutMixin from "../../mixins/table-layout-mixin"
    import addPopup from "./modal/add"
    import editPopup from "./modal/editNew"
    import api from '@/api'
    import { dictionaryDefault } from '@/translations/ru/default'
    import { dictionary } from '@/translations/ru/settings__sb_settings__participant_cards'

    // TODO Тестовые данные

    export default {
        name: "card-field",
        components: {
            ObTable,
            addPopup,
            editPopup,
            ObModal
        },
        mixins: [
          tableLayoutMixin
        ],
        data() {
            return {
                propertyId: 'uuid',
                openAddPopup: false,
                openEditPopup: false,
                formData: {},
                formDataArray: [],
                rolesList: [],
                dictionaryRu: Object.assign(dictionary, dictionaryDefault)
            }
        },
        created () {
            this.fetchFields()
        },
        computed: {
            docTypes() {
                return this.dictionaryRu.doc_types;
            },
            systemTitle() {
                return this.dictionaryRu.editWindow.editSystemWindowTitle;
            },
            newTitle() {
                return this.dictionaryRu.editWindow.newWindowTitle;
            },
            columns() {
                let _self = this;
                return [
                    {
                        title: this.dictionaryRu.columns.title,
                        key: 'title',
                    },
                    {
                        title: this.dictionaryRu.columns.country,
                        key: 'country',
                        html: (data) => {
                            return data.countries.map(c => c.name).join(',')
                        }
                    },
                    {
                        title: this.dictionaryRu.columns.form_type,
                        key: 'legal_entity_types',
                        html: (data) => {
                            if (data.legal_entity_types.length) {
                                return data.legal_entity_types.map(item => item.title).join(', ')
                            }
                            return ''
                        }
                    },
                    {
                        title: this.dictionaryRu.columns.rule,
                        key: 'participant_role_codes',
                        html: (data) => {
                            if (data.participant_role_codes.length) {
                                return data.participant_role_codes.map(code => _self.getRoleTitle(code)).join(', ')
                            }
                            return ''
                        }
                    },
                    {
                        title: this.dictionaryRu.columns.direction,
                        key: 'activities',
                        html: (data) => {
                            if (data.activities.length) {
                                return data.activities.map(item => item.title).join(', ')
                            }
                            return ''
                        }
                    },
                    {
                        title: this.dictionaryRu.columns.status,
                        key: 'is_active',
                        html: (data) => {
                            if(data.deleted) {
                                return '<div class="not-active">' + this.dictionaryRu.status.inactive + '</div>';
                            }
                            return '<div>' + this.dictionaryRu.status.active + '</div>';
                        }
                    }
                ]
            },
            systemReason() {
                return this.formData ? this.formData.system : false;
            },
            titleReason() {
                if(this.newStatus) {
                    return this.newTitle;
                }
                if(this.systemReason) {
                    return this.systemTitle;
                }
                return this.editTitle
            }
        },
        methods: {
            async fetchFields () {
                try {
                    this.formDataArray = await api.card.fetch()

                    let roles = await api.cardField.getRoles()
                    this.rolesList = roles.content
                } catch (e) {
                    console.error(e);
                    this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
                }
            },
            async addNewItem() {
                this.$refs.addModal.open()
            },
            async save() {
                this.fetchFields()
                this.$refs.addModal.close()
            },
            async onSelection(data) {
                try {
                    let risks = await api.card.getRiskParticipant(data.uuid)
                    let resData = await api.card.getParticipantDetail(data.uuid)
                    this.formData = {...resData, ...{riskValues: risks}, uuid: data.uuid}
                    this.$refs.editModal.open({data: this.formData})
                } catch (e) {
                    console.error(e);
                    this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
                }
            },
            getRoleTitle (code) {
                let role = this.rolesList.find(item => item.code === code)
                return role ? role.title : ''
            }
        }
    }
</script>

<style lang="scss">
    .color-error {
        color: $color-error;
    }
</style>
